	#include <strings.h>

	char* hostname;
	struct node { struct node* next; char* hname; };
	struct node *tcpn, *icmpn;
	
	void dodajtcp(char*);
	void dodajicmp(char*);

%s tcp tcpok icmp icmpok
%array

CZAS	([0-1][0-9]|2[0-3])":"[0-5][0-9]":"[0-5][0-9]"."[0-9]{6}
HOST	([A-Za-z][a-zA-Z0-9\-]*[a-zA-Z0-9]".")*[A-Za-z][a-zA-Z0-9\-]*[a-zA-Z0-9]
IP	(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])"."){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])
PORT	[1-9]([0-9]{0,3})|[0-5]([0-9]{4})|6[0-4]([0-9]{3})|65[0-4]([0-9]{2})|655[0-2][0-9]|6553[0-5]

%%

^{CZAS}" IP "({HOST}|{IP})"."{PORT}" > "({HOST}|{IP})"."{PORT}": S ".*\n	BEGIN(tcp); yyless(19);
<tcp>{HOST}|{IP} {
	if (!strcasecmp(hostname, yytext))
		BEGIN(tcpok);
	else
		BEGIN(0);
}
<tcpok>"."{PORT}" > "
<tcpok>{HOST}|{IP} {
	if (bylotcp(yytext))
		BEGIN(0);
	else {
		printf("%s", yytext);
		dodajtcp(yytext);
	}
}
<tcpok>"."
<tcpok>{PORT}	printf(" tcp %s\n", yytext); BEGIN(0);

^{CZAS}" IP "({HOST}|{IP})" > "({HOST}|{IP})": icmp ".*\n	BEGIN(icmp); yyless(19);
<icmp>{HOST}|{IP} {
	if (!strcasecmp(hostname, yytext))
		BEGIN(icmpok);
	else
		BEGIN(0);
}
<icmpok>" > "
<icmpok>{HOST}|{IP} {
	if (byloicmp(yytext))
		BEGIN(0);
	else {
		printf("%s icmp\n", yytext);
		dodajicmp(yytext);
		BEGIN(0);
	}
}

\n
.
%%

void dodajtcp(char* txt) {
	struct node* tmp;

	if (!tcpn) {
		tcpn = (struct node*)malloc(sizeof(struct node));
		tcpn->hname = strdup(txt);
		tcpn->next = 0;
	} else {
		tmp = malloc(sizeof(struct node));
		tmp->hname = strdup(txt);
		tmp->next = tcpn;
		tcpn = tmp;
	}
}

void dodajicmp(char* txt) {
	struct node* tmp;

	if (!icmpn) {
		icmpn = malloc(sizeof(struct node));
		icmpn->hname = strdup(txt);
		icmpn->next = 0;
	} else {
		tmp = malloc(sizeof(struct node));
		tmp->hname = strdup(txt);
		tmp->next = icmpn;
		icmpn = tmp;
	}
}

int bylotcp(char* txt) {
	struct node* tmp = tcpn;

	if (!tcpn)
		return 0;
	
	do {
		if (!strcasecmp(tmp->hname, txt))
			return 1;
		tmp = tmp->next;
	} while (tmp);
	
	return 0;
}

int byloicmp(char* txt) {
	struct node* tmp = icmpn;

	if (!icmpn)
		return 0;
	
	do {
		if (!strcasecmp(tmp->hname, txt))
			return 1;
		tmp = tmp->next;
	} while (tmp);
	
	return 0;
}

int main(int argc, char** argv) {
	if (argc<2) {
		fprintf(stderr, "argument: nazwa_hosta\n");
		return EXIT_FAILURE;
	}
	
	tcpn = icmpn = 0;
	
	hostname = malloc(strlen(argv[1])+1);
	strcpy(hostname, argv[1]);
	
	yylex();
	return EXIT_SUCCESS;
}
